/****************************************************
 * HiQUE Dumb Computer implementation
 *
 * This code is intended only as an example of
 * how to implement an AI game playing client
 * that will interface with the game manager.
 *
 * This particular AI simply selects a
 * random move that it finds is valid.
 *
 * Feel free to use any code from this file.
 *
 * Kenrick Mock 3/3/02
 *
 ****************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "globals.h"
#include "client_ai.h"
#include "move.h"
#include "movelist.h"

/***************************************************
 * This function returns a random move
 * that is valid.  
 *
 * You should replace this with your own AI routine
 * to do minimax or whatever search.
 ***************************************************/

void ComputeMove(char board[DIM][DIM], char whoseturn, 
	int *x1, int *y1, int *x2, int *y2)
{
 movelist m;
 int i;

 GenerateMoves(board, whoseturn, &m);
 i = rand() % GetNumMoves(m);
 *x1 = m.mval[i].oldx;
 *y1 = m.mval[i].oldy;
 *x2 = m.mval[i].newx;
 *y2 = m.mval[i].newy;
 return;
}


