/******************************************************************
 * 3/3/02 KJM
 *
 * Dumb HiQUE player.  This program is intended as an example
 * of how to interface with the game manager.  Feel free to use
 * any code from here as you see fit.
 *******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "globals.h"
#include "client_io.h"
#include "client_ai.h"
#include "board.h"
#include "move.h"

/*************************************************************
 *
 * The format we are expecting arguments is:
 *
 * argv[0] = program name   (ignore)
 * argv[1] = "white" or "black" depending on which player we are
 *
 * If we are black, then we move first.  
 *
 *************************************************************/
void ShowUsage();

main(int argc, char *argv[])
{
 char board[DIM][DIM];				/* Main Game Board */
 int i;						/* Loop */
 int iWeMoveFirst;				/* We move first? */
 int iCount1, iCount2;				/* Counters for data structs */
 int x1,y1,x2,y2;				/* The Move */
 char ourcolor;
 
 /* For the following routines, you will have to modify this
    code to initialize whatever structures you are using to
    represent the game board, color assignments, etc.
    First extract what color we are and who moves first.
 */
 if (argc!=2) { 
   ShowUsage();
   exit(0);
 }

 if (!strcmp(argv[1],"white")) {
   iWeMoveFirst=0;		/* We move second */
   ourcolor = 'w';
 }
 else {
   iWeMoveFirst=1;		/* We move first */
   ourcolor = 'b';
 }


 /* The following initializes some internal structures to 
    play the game.  This program needs it, but yours
    may not if your board data structures are set up differently.
 */
 InitBoard(board);
 g_num_white = 5;
 g_num_black = 5;
 srand(getpid());  /* Seed rand num generator with our PID, not very random */

 
 /*************************** MAIN PROGRAM LOOP *******************/
  
 if (iWeMoveFirst) {       
    ComputeMove(board,'b',&x1,&y1,&x2,&y2);  /* Replace with your AI routine */
    ApplyMove(board,x1,y1,x2,y2,0);
    SendMoveToOpponent(x1,y1,x2,y2);
 } 

 /* Loop forever, getting a move and then sending our reply move.
    Assumes the server will stop the game when a winner is found
    so we don't check for game over here.
    Also assumed the moves we get are valid :-)
 */

 while(1) {
    GetMoveFromOpponent(&x1,&y1,&x2,&y2);
    ApplyMove(board,x1,y1,x2,y2,0);
    ComputeMove(board,ourcolor,&x1,&y1,&x2,&y2);  /* Replace with your AI */
    ApplyMove(board,x1,y1,x2,y2,0);
    SendMoveToOpponent(x1,y1,x2,y2);
 }
}



void ShowUsage()
{
   printf("Usage: dumbclient white | black\n");
   printf("e.g.: \"dumbclient white\" for this program to play as white and move second.\n");
   printf("Intended for usage only from the game manager program.\n");
}

